xref: /haiku/configure (revision 502882dbd93cecb448cf2b79b2f2ceccd8313e7a)
152a38012Sejakowatz#!/bin/sh
252a38012Sejakowatz#
3338b8dc3SIngo Weinhold# configure [ <options> ]
4614026d7Sshatty
539d444a3SArvind S Raj# set flag to exit script when exit command is executed
639d444a3SArvind S Rajset -e
739d444a3SArvind S Raj
8022fa244SIngo Weinhold# usage
9022fa244SIngo Weinhold#
10022fa244SIngo Weinhold# Prints usage.
11022fa244SIngo Weinhold#
12022fa244SIngo Weinholdusage()
13022fa244SIngo Weinhold{
14022fa244SIngo Weinhold	cat << EOF
15022fa244SIngo Weinhold
16022fa244SIngo WeinholdUsage: $0 <options>
17022fa244SIngo Weinholdoptions:
18e173a1ecSIngo Weinhold  --bootstrap <haikuporter> <HaikuPorts cross repo> <HaikuPorts repo>
19e173a1ecSIngo Weinhold                              Prepare for a bootstrap build. No pre-built
20e173a1ecSIngo Weinhold                              packages will be used, instead they will be built
21e173a1ecSIngo Weinhold                              from the sources (in several phases).
22e173a1ecSIngo Weinhold                              <haikuporter> is the path to the haikuporter tool
23e173a1ecSIngo Weinhold                              suitable for the host platform.
24e173a1ecSIngo Weinhold                              <HaikuPorts cross repo> is the path to a checked
25e173a1ecSIngo Weinhold                              out HaikuPorts cross-compilation repository.
26e173a1ecSIngo Weinhold                              <HaikuPorts repo> is the path to a checked out
27e173a1ecSIngo Weinhold                              HaikuPorts repository.
28c0e8cc1aSIngo Weinhold  --build-cross-tools <arch> [ <build tools dir> ]
29338b8dc3SIngo Weinhold                              Assume cross compilation. <build tools dir>
30338b8dc3SIngo Weinhold                              defines the location of the build tools sources.
31338b8dc3SIngo Weinhold                              They will be compiled and placed in the output
32a5b60fa8SOliver Tappe                              directory under "cross-tools". The HAIKU_* tools
33a5b60fa8SOliver Tappe                              variables will be set accordingly.
3420ab75e6SIngo Weinhold                              <arch> specifies the target architecture, either
351b38c341SAlexander von Gluck IV                              "x86_gcc2", "x86", "x86_64", "ppc", "m68k", "arm"
36c0e8cc1aSIngo Weinhold                              This option and --cross-tools-prefix can be
37c0e8cc1aSIngo Weinhold                              specified multiple times. The first cross tools
38c0e8cc1aSIngo Weinhold                              specify the primary tools, the subsequent ones the
39c0e8cc1aSIngo Weinhold                              secondary tools (for "hybrid" images).
40c0e8cc1aSIngo Weinhold                              For the first --build-cross-tools the
41c0e8cc1aSIngo Weinhold                              <build tools dir> argument must be specified and
42c0e8cc1aSIngo Weinhold                              for the subsequent ones it must be omitted.
43eccc7665SIngo Weinhold  --cross-tools-prefix <prefix>
44eccc7665SIngo Weinhold                              Assume cross compilation. <prefix> should be a
45eccc7665SIngo Weinhold                              path to the directory where the cross
46eccc7665SIngo Weinhold                              compilation tools are located, plus the platform
470da9c208SIngo Weinhold                              prefix, e.g. "/path/to/tools/i586-pc-haiku-".
48eccc7665SIngo Weinhold                              This overrides the HAIKU_* tool variables.
49a66c32ddSIngo Weinhold  --distro-compatibility <level>
50a66c32ddSIngo Weinhold                              The distribution's level of compatibility with
51a66c32ddSIngo Weinhold                              the official Haiku distribution. The generated
52a66c32ddSIngo Weinhold                              files will contain the respective trademarks
53a66c32ddSIngo Weinhold                              accordingly.
54a66c32ddSIngo Weinhold                              official -- the official Haiku distribution.
55a66c32ddSIngo Weinhold                              compatible -- a Haiku Compatible (tm) distro.
56a66c32ddSIngo Weinhold                              default -- any other distro (default value).
5760d8d8fcSIngo Weinhold  --enable-multiuser          Enable experimental multiuser support.
58eccc7665SIngo Weinhold  --help                      Prints out this help.
592ebcd86dSIngo Weinhold  --host-only                 Configure for building tools for the build host
602ebcd86dSIngo Weinhold                              only. Haiku cannot be built when configured like
612ebcd86dSIngo Weinhold                              this.
62eccc7665SIngo Weinhold  --include-gpl-addons        Include GPL licensed add-ons.
6367838392SAxel Dörfler  --include-patented-code     Enable code that is known to implemented patented
6467838392SAxel Dörfler                              ideas and techniques. If this option is not
6567838392SAxel Dörfler                              specified, the resulting distribution may still
6667838392SAxel Dörfler                              implement patented ideas and techniques. This
6767838392SAxel Dörfler                              option only disables code that is currently known
6867838392SAxel Dörfler                              to be problematic.
6976fa0be3SIngo Weinhold  --include-sources           Includes the source code of projects that require
7076fa0be3SIngo Weinhold                              either an offer of source code or a copy of the
7176fa0be3SIngo Weinhold                              patched sources. This is preferable when
7276fa0be3SIngo Weinhold                              distributing on physical mediums.
731974210fSFrançois Revol  --include-3rdparty          Include 3rdparty/ in the build system.
7460d8d8fcSIngo Weinhold  -j<n>                       Only relevant for --build-cross-tools and
7560d8d8fcSIngo Weinhold                              --build-cross-tools-gcc4. Is passed on to the
7660d8d8fcSIngo Weinhold                              make building the build tools.
7786d7e283SOliver Tappe  --remote-user <username>    Use given username when logging into
7886d7e283SOliver Tappe                              git.haiku-os.org (via ssh).
797c4641d0SOliver Tappe  --target=TARGET             Select build target platform.
807c4641d0SOliver Tappe                              [default=${TARGET_PLATFORM}]
81a17b9c0cSshatty                              valid targets=r5,bone,dano,haiku
82483b28e4SIngo Weinhold  --target-arch <arch>        Haiku only: Specify the target architecture to
83483b28e4SIngo Weinhold                              build for. Must be one of the architectures of the
84483b28e4SIngo Weinhold                              host system. The installed build tools for that
85483b28e4SIngo Weinhold                              architecture will be used.
86483b28e4SIngo Weinhold                              This option can be specified multiple times. The
87483b28e4SIngo Weinhold                              first occurrence specifies the primary
88483b28e4SIngo Weinhold                              architecture of the Haiku to build, subsequent
89483b28e4SIngo Weinhold                              ones the secondary architectures.
90e70c4c64SPulkoMandy  --target-board <board>      ARM only: Specify the board to build for. Must be
91e70c4c64SPulkoMandy                              one of beagle,pi,verdex.
927c4641d0SOliver Tappe  --update                    re-runs last configure invocation [must be given
937c4641d0SOliver Tappe                              as first option!]
94c2b76f7fSJonathan Schleifer  --use-clang                 Build with host Clang instead of GCC cross
95c2b76f7fSJonathan Schleifer                              compiler
96eccc7665SIngo Weinhold  --use-gcc-pipe              Build with GCC option -pipe. Speeds up the build
975a34a443SFrançois Revol                              process, but uses more memory.
98ed38d2efSJerome Duval  --use-gcc-graphite          Build with GCC Graphite engine for loop
99ed38d2efSJerome Duval                              optimizations. Only for gcc 4.
1000385b065SIngo Weinhold  --use-32bit                 Use -m32 flag on 64bit host gcc compiler.
101bc96e8f3SIngo Weinhold  --use-xattr                 Use Linux xattr respectively *BSD extattr support
102bc96e8f3SIngo Weinhold                              for BeOS attribute emulation. Warning: Make sure
103bc96e8f3SIngo Weinhold                              your file system supports sufficient attribute
104bc96e8f3SIngo Weinhold                              sizes (4 KB per file for all attributes won't
105bc96e8f3SIngo Weinhold                              suffice).
106bc96e8f3SIngo Weinhold  --use-xattr-ref             Use the generic BeOS attribute emulation, but use
107bc96e8f3SIngo Weinhold                              Linux xattr respectively *BSD extattr support to
108bc96e8f3SIngo Weinhold                              make it more robust (i.e. attribute mix-ups become
109bc96e8f3SIngo Weinhold                              less likely).
110338b8dc3SIngo Weinhold
111338b8dc3SIngo Weinholdenvironment variables:
112c0e8cc1aSIngo Weinhold  HAIKU_AR_x86_gcc2           The static library archiver for x86_gcc2.
113c0e8cc1aSIngo Weinhold                              Defaults to "ar".
114c0e8cc1aSIngo Weinhold  HAIKU_CC_x86_gcc2           The x86_gcc2 compiler. Defaults to "gcc".
115c0e8cc1aSIngo Weinhold  HAIKU_LD_x86_gcc2           The x86_gcc2 linker. Defaults to "ld".
116c0e8cc1aSIngo Weinhold  HAIKU_OBJCOPY_x86_gcc2      The x86_gcc2 objcopy to be used. Defaults to
117c0e8cc1aSIngo Weinhold                              "objcopy".
118c0e8cc1aSIngo Weinhold  HAIKU_RANLIB_x86_gcc2       The static library indexer for x86_gcc2. Defaults
119c0e8cc1aSIngo Weinhold                              to "ranlib".
120c0e8cc1aSIngo Weinhold  HAIKU_STRIP_x86_gcc2        The x86_gcc2 strip command. Defaults to "strip".
121a04a520bSJonathan Schleifer  HAIKU_NASM                  The nasm assembler (x86 and x86_64 only).
122c0e8cc1aSIngo Weinhold  HAIKU_CPPFLAGS_<arch>       The preprocessor flags for target architecture
123c0e8cc1aSIngo Weinhold                              <arch>. Defaults to "".
124c0e8cc1aSIngo Weinhold  HAIKU_CCFLAGS_<arch>        The C flags for target architecture <arch>.
125c0e8cc1aSIngo Weinhold                              Defaults to "".
126c0e8cc1aSIngo Weinhold  HAIKU_CXXFLAGS_<arch>       The C++ flags for target architecture <arch>.
127c0e8cc1aSIngo Weinhold                              Defaults to "".
128c0e8cc1aSIngo Weinhold  HAIKU_LDFLAGS_<arch>        The linker flags for target architecture <arch>.
129c0e8cc1aSIngo Weinhold                              Defaults to "".
130c0e8cc1aSIngo Weinhold  HAIKU_ARFLAGS_<arch>        The flags passed to HAIKU_AR for target
131c0e8cc1aSIngo Weinhold                              architecture <arch> for archiving. Defaults to
132c0e8cc1aSIngo Weinhold                              "cru".
133c0e8cc1aSIngo Weinhold  HAIKU_UNARFLAGS_<arch>      The flags passed to HAIKU_AR for target
134c0e8cc1aSIngo Weinhold                              architecture <arch> for unarchiving. Defaults to
135c0e8cc1aSIngo Weinhold                              "x".
13664f6da31SIngo Weinhold
137c0e8cc1aSIngo WeinholdNon-default output directories:
13864f6da31SIngo Weinhold  By default all objects, build configuration, and other related files are
13964f6da31SIngo Weinhold  stored in /path/to/haiku_source/generated.  To store objects in a non-default
14064f6da31SIngo Weinhold  location, run "../../relative/path/to/haiku_source/configure <options>" from
14164f6da31SIngo Weinhold  within your non-default location.  "jam [ options ] targets" can then be run
14264f6da31SIngo Weinhold  directly inside your non-default location.  Another option is to invoke "jam
14364f6da31SIngo Weinhold  [ options ] targets" from within haiku_source.  This can be accomplished by
14464f6da31SIngo Weinhold  either "export HAIKU_OUTPUT_DIR=your non-default location" before invoking
14564f6da31SIngo Weinhold  jam or by creating a symlink of haiku_source/generated pointing to your
14664f6da31SIngo Weinhold  non-default location and running jam.
14764f6da31SIngo Weinhold
14864f6da31SIngo Weinhold
149022fa244SIngo WeinholdEOF
150022fa244SIngo Weinhold}
151022fa244SIngo Weinhold
152022fa244SIngo Weinhold# assertparam
153022fa244SIngo Weinhold#
154022fa244SIngo Weinhold# Checks whether at least one parameter is left.
155022fa244SIngo Weinhold#
156022fa244SIngo Weinholdassertparam()
157022fa244SIngo Weinhold{
15820ab75e6SIngo Weinhold	if [ $2 -lt 2 ]; then
159022fa244SIngo Weinhold		echo $0: \`$1\': Parameter expected.
160022fa244SIngo Weinhold		exit 1
161022fa244SIngo Weinhold	fi
162022fa244SIngo Weinhold}
163022fa244SIngo Weinhold
16420ab75e6SIngo Weinhold# assertparams
16520ab75e6SIngo Weinhold#
16620ab75e6SIngo Weinhold# Checks whether at least a certain number of parameters is left.
16720ab75e6SIngo Weinhold#
16820ab75e6SIngo Weinholdassertparams()
16920ab75e6SIngo Weinhold{
17020ab75e6SIngo Weinhold	if [ $3 -le $2 ]; then
17120ab75e6SIngo Weinhold		echo $0: \`$1\': Not enough parameters.
17220ab75e6SIngo Weinhold		exit 1
17320ab75e6SIngo Weinhold	fi
17420ab75e6SIngo Weinhold}
17520ab75e6SIngo Weinhold
176e173a1ecSIngo Weinhold# absolute_path
177e173a1ecSIngo Weinhold#
178e173a1ecSIngo Weinhold# returns the absolute path of a given path.
179e173a1ecSIngo Weinhold#
180e173a1ecSIngo Weinholdabsolute_path()
181e173a1ecSIngo Weinhold{
1826a4f3954SFrançois Revol	if [ "x$1" != "x${1#/}" ]; then
183e173a1ecSIngo Weinhold		echo "$1"
184e173a1ecSIngo Weinhold	else
185e173a1ecSIngo Weinhold		echo "`pwd`/$1"
186e173a1ecSIngo Weinhold	fi
187e173a1ecSIngo Weinhold}
188e173a1ecSIngo Weinhold
18939d444a3SArvind S Raj# check_dir_exists
19039d444a3SArvind S Raj#
19139d444a3SArvind S Raj# check if a directory exists or not
19239d444a3SArvind S Raj#
19339d444a3SArvind S Rajcheck_dir_exists()
19439d444a3SArvind S Raj{
19539d444a3SArvind S Raj	if [ -d "$1" ]; then
19639d444a3SArvind S Raj		return 0
19739d444a3SArvind S Raj	else
19839d444a3SArvind S Raj		return 1
19939d444a3SArvind S Raj	fi
20039d444a3SArvind S Raj}
20139d444a3SArvind S Raj
202*502882dbSJessica Hamilton# check_file_exists
203*502882dbSJessica Hamilton#
204*502882dbSJessica Hamilton# check if a file exists or not
205*502882dbSJessica Hamilton#
206*502882dbSJessica Hamiltoncheck_file_exists()
207*502882dbSJessica Hamilton{
208*502882dbSJessica Hamilton	if [ -f "$1" ]; then
209*502882dbSJessica Hamilton		return 0
210*502882dbSJessica Hamilton	else
211*502882dbSJessica Hamilton		return 1
212*502882dbSJessica Hamilton	fi
213*502882dbSJessica Hamilton}
214*502882dbSJessica Hamilton
2159a001156SOliver Tappe# real_path
2169a001156SOliver Tappe#
2179a001156SOliver Tappe# returns the realpath of a symbolic link.
2189a001156SOliver Tappe#
2199a001156SOliver Tappereal_path()
2209a001156SOliver Tappe{
2219a001156SOliver Tappe	perl -MCwd=realpath -e'print realpath($ARGV[0]), "\n"' "$1"
2229a001156SOliver Tappe}
2239a001156SOliver Tappe
22409c5682dSIngo Weinhold# standard_gcc_settings
22509c5682dSIngo Weinhold#
22609c5682dSIngo Weinhold# Sets the variables for a GCC platform.
22709c5682dSIngo Weinhold#
22809c5682dSIngo Weinholdstandard_gcc_settings()
22909c5682dSIngo Weinhold{
230c0e8cc1aSIngo Weinhold	local gcc=$1
231c0e8cc1aSIngo Weinhold
232138f5fb4SIngo Weinhold	if which greadlink > /dev/null 2>&1; then
233b29b48b1SMatt Madia		readlink="greadlink -e"
234138f5fb4SIngo Weinhold	elif which realpath > /dev/null 2>&1; then
235b29b48b1SMatt Madia		readlink=realpath
2369a001156SOliver Tappe	elif readlink -e / > /dev/null 2>&1; then
237b29b48b1SMatt Madia		readlink="readlink -e"
2389a001156SOliver Tappe	else
2399a001156SOliver Tappe		readlink=real_path
240b4b6d83cSMatt Madia	fi
241138f5fb4SIngo Weinhold
24209c5682dSIngo Weinhold	# PLATFORM_LINKLIBS
243c0e8cc1aSIngo Weinhold	local gcclib=`$gcc -print-libgcc-file-name`
244c0e8cc1aSIngo Weinhold	local gccdir=`dirname ${gcclib}`
2455b0f7b1bSOliver Tappe
246c0e8cc1aSIngo Weinhold	local gccRawVersion=`$gcc -dumpversion`
247c0e8cc1aSIngo Weinhold	local gccMachine=`$gcc -dumpmachine`
248338b8dc3SIngo Weinhold
249c0e8cc1aSIngo Weinhold	local libgcc=${gccdir}/libgcc.a
2508b5934c9SIngo Weinhold
251fc8967f1SIngo Weinhold	# determine architecture from machine triple
252c0e8cc1aSIngo Weinhold	case $gccMachine in
253c0e8cc1aSIngo Weinhold		arm-*)		targetCpu=arm;;
254c0e8cc1aSIngo Weinhold		i?86-*)		targetCpu=x86;;
255c0e8cc1aSIngo Weinhold		m68k-*)		targetCpu=m68k;;
256c0e8cc1aSIngo Weinhold		powerpc-*)	targetCpu=ppc;;
257c0e8cc1aSIngo Weinhold		x86_64-*)	targetCpu=x86_64;;
258fc8967f1SIngo Weinhold		*)
259c0e8cc1aSIngo Weinhold			echo "Unsupported gcc target machine: $gccMachine" >&2
260fc8967f1SIngo Weinhold			exit 1
261fc8967f1SIngo Weinhold			;;
262fc8967f1SIngo Weinhold	esac
263fc8967f1SIngo Weinhold
264c0e8cc1aSIngo Weinhold	local targetArch=$targetCpu
265c0e8cc1aSIngo Weinhold	local staticLibStdCxx
266c0e8cc1aSIngo Weinhold	local sharedLibStdCxx
267c0e8cc1aSIngo Weinhold	local staticLibSupCxx
268c0e8cc1aSIngo Weinhold	local sharedLibSupCxx
269c0e8cc1aSIngo Weinhold	local kernelLibgcc
270c0e8cc1aSIngo Weinhold	local cxxHeaders
271fc8967f1SIngo Weinhold
272c0e8cc1aSIngo Weinhold	case $gccRawVersion in
2738b5934c9SIngo Weinhold		4.*)
2745b0f7b1bSOliver Tappe			# for gcc 4 we use the libstdc++ and libsupc++ that come with the
2755b0f7b1bSOliver Tappe			# compiler
276c0e8cc1aSIngo Weinhold			staticLibStdCxx=`$gcc -print-file-name=libstdc++.a`
277c0e8cc1aSIngo Weinhold			sharedLibStdCxx=`$gcc -print-file-name=libstdc++.so`
278c0e8cc1aSIngo Weinhold			staticLibSupCxx=`$gcc -print-file-name=libsupc++.a`
279c0e8cc1aSIngo Weinhold			sharedLibSupCxx=`$gcc -print-file-name=libsupc++.so`
28014210488SMichael Lotz
281aaeadfcbSAlex Smith			# If the architecture has separate runtime libraries for the
282aaeadfcbSAlex Smith			# kernel, use them.
283c0e8cc1aSIngo Weinhold			kernelLibgcc=`$gcc -print-file-name=libgcc-kernel.a`
284c0e8cc1aSIngo Weinhold			if [ $kernelLibgcc = libgcc-kernel.a ]; then
285c0e8cc1aSIngo Weinhold				kernelLibgcc=$libgcc
286aaeadfcbSAlex Smith			fi
287c0e8cc1aSIngo Weinhold			kernelLibSupCxx=`$gcc -print-file-name=libsupc++-kernel.a`
288c0e8cc1aSIngo Weinhold			if [ $kernelLibSupCxx = libsupc++-kernel.a ]; then
289c0e8cc1aSIngo Weinhold				kernelLibSupCxx=$staticLibSupCxx
290aaeadfcbSAlex Smith			fi
291aaeadfcbSAlex Smith
292c0e8cc1aSIngo Weinhold			local headersBase=$gccdir/../../../..
293c0e8cc1aSIngo Weinhold			local headers=$headersBase/$gccMachine/include/c++/$gccRawVersion
294c0e8cc1aSIngo Weinhold			if [ ! -d $headers ]; then
295c0e8cc1aSIngo Weinhold				headers=$headersBase/include/c++/$gccRawVersion
29614210488SMichael Lotz			fi
29714210488SMichael Lotz
298c0e8cc1aSIngo Weinhold			cxxHeaders=$headers
299c0e8cc1aSIngo Weinhold			for d in $gccMachine backward ext; do
30029ef597dSIngo Weinhold				# Note: We need the line break, otherwise the line might become
30129ef597dSIngo Weinhold				# too long for jam (512 bytes max).
302c0e8cc1aSIngo Weinhold				cxxHeaders="$cxxHeaders $headers/$d"
3038b5934c9SIngo Weinhold			done
304274b450aSMarcus Overhagen
3053f9f9f9aSIngo Weinhold			# Unset the HAIKU_{SHARED,STATIC}_LIB{STD,SUP}CXX variables, if the
3063f9f9f9aSIngo Weinhold			# compiler didn't give us actual file names. Otherwise resolve
3073f9f9f9aSIngo Weinhold			# symlinks to avoid problems when copying the libraries to the
3083f9f9f9aSIngo Weinhold			# image.
3098b5934c9SIngo Weinhold
310c0e8cc1aSIngo Weinhold			if [ $staticLibStdCxx = libstdc++.a ]; then
311c0e8cc1aSIngo Weinhold				staticLibStdCxx=
3123f9f9f9aSIngo Weinhold			else
313c0e8cc1aSIngo Weinhold				staticLibStdCxx=`$readlink $staticLibStdCxx`
3148b5934c9SIngo Weinhold			fi
3153f9f9f9aSIngo Weinhold
316c0e8cc1aSIngo Weinhold			if [ $sharedLibStdCxx = libstdc++.so ]; then
317c0e8cc1aSIngo Weinhold				sharedLibStdCxx=
3183f9f9f9aSIngo Weinhold			else
319c0e8cc1aSIngo Weinhold				sharedLibStdCxx=`$readlink $sharedLibStdCxx`
320ffe8b20cSIngo Weinhold			fi
3213f9f9f9aSIngo Weinhold
322c0e8cc1aSIngo Weinhold			if [ $staticLibSupCxx = libsupc++.a ]; then
323c0e8cc1aSIngo Weinhold				staticLibSupCxx=
3243f9f9f9aSIngo Weinhold			else
325c0e8cc1aSIngo Weinhold				staticLibSupCxx=`$readlink $staticLibSupCxx`
326c89fc875SIngo Weinhold			fi
3273f9f9f9aSIngo Weinhold
328c0e8cc1aSIngo Weinhold			if [ $sharedLibSupCxx = libsupc++.so ]; then
329c0e8cc1aSIngo Weinhold				sharedLibSupCxx=
3303f9f9f9aSIngo Weinhold			else
331c0e8cc1aSIngo Weinhold				sharedLibSupCxx=`$readlink $sharedLibSupCxx`
332ffe8b20cSIngo Weinhold			fi
3338b5934c9SIngo Weinhold			;;
3346cc8eecfSOliver Tappe		2.9*)
3355b0f7b1bSOliver Tappe			# check for correct (most up-to-date) legacy compiler and complain
3365b0f7b1bSOliver Tappe			# if an older one is installed
337c0e8cc1aSIngo Weinhold			if [ $gccRawVersion != $haikuRequiredLegacyGCCVersion ]; then
3385b0f7b1bSOliver Tappe				echo "GCC version $haikuRequiredLegacyGCCVersion is required!";
3395b0f7b1bSOliver Tappe				echo "Please download it from www.haiku-os.org...";
3405b0f7b1bSOliver Tappe				exit 1;
3415b0f7b1bSOliver Tappe			fi
342aaeadfcbSAlex Smith
343c0e8cc1aSIngo Weinhold			kernelLibgcc=$libgcc
344c0e8cc1aSIngo Weinhold			kernelLibSupCxx=
345c0e8cc1aSIngo Weinhold			targetArch=x86_gcc2
3465b0f7b1bSOliver Tappe			;;
3478b5934c9SIngo Weinhold	esac
34865ad1ba3SAlex Smith
349c0e8cc1aSIngo Weinhold	local bootLibgcc
350c0e8cc1aSIngo Weinhold	local bootLibSupCxx
35166a7f29fSJérôme Duval	local bootCxxHeaders
352c0e8cc1aSIngo Weinhold	case $gccMachine in
3534591ebc9SAlex Smith		x86_64-*)
35466a7f29fSJérôme Duval			# Boot loader is 32-bit, need the 32-bit libs and c++ config
355c0e8cc1aSIngo Weinhold			bootLibgcc=`$gcc -m32 -print-libgcc-file-name`
356c0e8cc1aSIngo Weinhold			bootLibSupCxx=`$gcc -m32 -print-file-name=libsupc++.a`
35766a7f29fSJérôme Duval
35866a7f29fSJérôme Duval			local headersBase=$gccdir/../../../..
35966a7f29fSJérôme Duval			local headers=$headersBase/$gccMachine/include/c++/$gccRawVersion
36066a7f29fSJérôme Duval			if [ ! -d $headers ]; then
36166a7f29fSJérôme Duval				headers=$headersBase/include/c++/$gccRawVersion
36266a7f29fSJérôme Duval			fi
36366a7f29fSJérôme Duval			bootCxxHeaders="$headers/$gccMachine/32"
3644591ebc9SAlex Smith			;;
3654591ebc9SAlex Smith		*)
366c0e8cc1aSIngo Weinhold			bootLibgcc=$libgcc
367c0e8cc1aSIngo Weinhold			bootLibSupCxx=$staticLibSupCxx
368338b8dc3SIngo Weinhold			;;
369338b8dc3SIngo Weinhold	esac
370c0e8cc1aSIngo Weinhold
371c0e8cc1aSIngo Weinhold	# determine whether graphite loop optimization should/can be used
372c0e8cc1aSIngo Weinhold	local useGraphite=`get_variable HAIKU_USE_GCC_GRAPHITE_$targetCpu`
373c0e8cc1aSIngo Weinhold	if [ -z "$useGraphite" ]; then
374c0e8cc1aSIngo Weinhold		useGraphite=$useGccGraphiteDefault
375c0e8cc1aSIngo Weinhold	fi
376c0e8cc1aSIngo Weinhold
377c0e8cc1aSIngo Weinhold	if [ "$useGraphite" != 0 ]; then
378c0e8cc1aSIngo Weinhold		UNUSED=`echo "int main() {}" | $gcc -xc -c -floop-block - 2>&1`
379c0e8cc1aSIngo Weinhold		if [ $? != 0 ]; then
380c0e8cc1aSIngo Weinhold			echo "GCC Graphite loop optimizations cannot be used on $targetArch"
381c0e8cc1aSIngo Weinhold			useGraphite=0
382c0e8cc1aSIngo Weinhold		fi
383c0e8cc1aSIngo Weinhold	fi
384c0e8cc1aSIngo Weinhold
385c0e8cc1aSIngo Weinhold	set_variable HAIKU_CPU_$targetArch $targetCpu
386c0e8cc1aSIngo Weinhold
387c0e8cc1aSIngo Weinhold	get_build_tool_path CC_$targetArch "$gcc"
388c2b76f7fSJonathan Schleifer	if [ $useClang = 1 ]; then
389c2b76f7fSJonathan Schleifer		# The get_build_tool_path above is needed to get the path to the rest
390c2b76f7fSJonathan Schleifer		# of the build tools
391c2b76f7fSJonathan Schleifer		local path=`dirname $(get_variable HAIKU_CC_$targetArch)`
392c2b76f7fSJonathan Schleifer		set_variable HAIKU_CC_$targetArch \
393c2b76f7fSJonathan Schleifer			"PATH=\\\"$path:\\\$PATH\\\" clang -target $gccMachine"
394c2b76f7fSJonathan Schleifer		set_variable HAIKU_CC_IS_CLANG_$targetArch 1
395c2b76f7fSJonathan Schleifer	else
396c2b76f7fSJonathan Schleifer		set_variable HAIKU_CC_IS_CLANG_$targetArch 0
397c2b76f7fSJonathan Schleifer	fi
398c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_RAW_VERSION_$targetArch $gccRawVersion
399c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_MACHINE_$targetArch $gccMachine
400c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_LIB_DIR_$targetArch $gccdir
401c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_LIBGCC_$targetArch $libgcc
402c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_GLUE_CODE_$targetArch "crtbegin.o crtend.o"
403c0e8cc1aSIngo Weinhold	set_variable HAIKU_GCC_HEADERS_DIR_$targetArch \
404c0e8cc1aSIngo Weinhold		"${gccdir}/include ${gccdir}/include-fixed"
405c0e8cc1aSIngo Weinhold	set_variable HAIKU_STATIC_LIBSTDCXX_$targetArch "$staticLibStdCxx"
406c0e8cc1aSIngo Weinhold	set_variable HAIKU_SHARED_LIBSTDCXX_$targetArch "$sharedLibStdCxx"
407c0e8cc1aSIngo Weinhold	set_variable HAIKU_STATIC_LIBSUPCXX_$targetArch "$staticLibSupCxx"
408c0e8cc1aSIngo Weinhold	set_variable HAIKU_SHARED_LIBSUPCXX_$targetArch "$sharedLibSupCxx"
409c0e8cc1aSIngo Weinhold	set_variable HAIKU_KERNEL_LIBSUPCXX_$targetArch "$kernelLibSupCxx"
410c0e8cc1aSIngo Weinhold	set_variable HAIKU_BOOT_LIBSUPCXX_$targetArch "$bootLibSupCxx"
411c0e8cc1aSIngo Weinhold	set_variable HAIKU_KERNEL_LIBGCC_$targetArch $kernelLibgcc
412c0e8cc1aSIngo Weinhold	set_variable HAIKU_CXX_HEADERS_DIR_$targetArch "$cxxHeaders"
413c0e8cc1aSIngo Weinhold	set_variable HAIKU_BOOT_LIBGCC_$targetArch $bootLibgcc
41466a7f29fSJérôme Duval	set_variable HAIKU_BOOT_CXX_HEADERS_DIR_$targetArch "$bootCxxHeaders"
415c0e8cc1aSIngo Weinhold	set_variable HAIKU_USE_GCC_GRAPHITE_$targetArch $useGraphite
416c0e8cc1aSIngo Weinhold
417c0e8cc1aSIngo Weinhold	standard_gcc_settings_targetArch=$targetArch
418c0e8cc1aSIngo Weinhold}
419c0e8cc1aSIngo Weinhold
420c0e8cc1aSIngo Weinhold# set_variable
421c0e8cc1aSIngo Weinhold#
422c0e8cc1aSIngo Weinhold# Set the value of a variable.
423c0e8cc1aSIngo Weinhold#
424c0e8cc1aSIngo Weinholdset_variable()
425c0e8cc1aSIngo Weinhold{
426c0e8cc1aSIngo Weinhold	eval "$1=\"$2\""
427c0e8cc1aSIngo Weinhold}
428c0e8cc1aSIngo Weinhold
429c0e8cc1aSIngo Weinhold# get_variable
430c0e8cc1aSIngo Weinhold#
431c0e8cc1aSIngo Weinhold# Echo the value of a variable.
432c0e8cc1aSIngo Weinhold#
433c0e8cc1aSIngo Weinholdget_variable()
434c0e8cc1aSIngo Weinhold{
435c0e8cc1aSIngo Weinhold	eval "echo \${$1}"
43609c5682dSIngo Weinhold}
43709c5682dSIngo Weinhold
438338b8dc3SIngo Weinhold# set_default_value
439338b8dc3SIngo Weinhold#
440338b8dc3SIngo Weinhold# Set the value for a variable, if no value is set yet.
441338b8dc3SIngo Weinhold#
442338b8dc3SIngo Weinholdset_default_value()
443338b8dc3SIngo Weinhold{
444338b8dc3SIngo Weinhold	eval "$1=\${$1-$2}"
445338b8dc3SIngo Weinhold}
446338b8dc3SIngo Weinhold
447338b8dc3SIngo Weinhold# get_build_tool_path
448338b8dc3SIngo Weinhold#
449338b8dc3SIngo Weinhold# Gets a usable absolute path of a build tool.
450338b8dc3SIngo Weinhold#
451338b8dc3SIngo Weinholdget_build_tool_path()
452338b8dc3SIngo Weinhold{
453338b8dc3SIngo Weinhold	local var="HAIKU_$1"
454c0e8cc1aSIngo Weinhold	local path=$2
455338b8dc3SIngo Weinhold
456338b8dc3SIngo Weinhold	if [ -f "$path" ]; then
457338b8dc3SIngo Weinhold		# get absolute path
458a559f87aSFrançois Revol		local oldPwd="`pwd`"
459a559f87aSFrançois Revol		cd "`dirname "$path"`"
460a559f87aSFrançois Revol		path="`pwd`/`basename "$path"`"
461338b8dc3SIngo Weinhold		cd $oldPwd
462338b8dc3SIngo Weinhold	else
4637fe2e06cSMatt Madia		which "$path" > /dev/null 2>&1 || {
464338b8dc3SIngo Weinhold			echo "Build tool \"$path\" not found." >&2
465338b8dc3SIngo Weinhold			exit 1
466338b8dc3SIngo Weinhold		}
467338b8dc3SIngo Weinhold	fi
468338b8dc3SIngo Weinhold
469338b8dc3SIngo Weinhold	eval "$var=$path"
470338b8dc3SIngo Weinhold}
471338b8dc3SIngo Weinhold
472483b28e4SIngo Weinholdis_in_list()
473483b28e4SIngo Weinhold{
474483b28e4SIngo Weinhold	local element
475483b28e4SIngo Weinhold	for element in $2; do
476483b28e4SIngo Weinhold		if [ "$1" = "$element" ]; then
477483b28e4SIngo Weinhold			return 0
478483b28e4SIngo Weinhold		fi
479483b28e4SIngo Weinhold	done
480483b28e4SIngo Weinhold	return 1
481483b28e4SIngo Weinhold}
482483b28e4SIngo Weinhold
483338b8dc3SIngo Weinhold# get cwd and the source directory
484338b8dc3SIngo WeinholdcurrentDir=`pwd`
4856e7c6fe5SIngo Weinholdcd `dirname "$0"`
486338b8dc3SIngo WeinholdsourceDir=`pwd`
4876e7c6fe5SIngo Weinholdcd "$currentDir"
488338b8dc3SIngo Weinhold
48955d267a4SFrançois Revol# backup the passed arguments
49055d267a4SFrançois RevolconfigureArgs="$@"
49155d267a4SFrançois Revol
4927c4641d0SOliver Tappe# internal default parameter values
493022fa244SIngo Weinhold#
49452a38012Sejakowatzplatform=`uname`
4955abd9a46SIngo WeinholdplatformMachine=`uname  -m`
496c0e8cc1aSIngo WeinholdtargetArchs=
497338b8dc3SIngo WeinholdbuildCrossTools=
49829ef597dSIngo WeinholdbuildCrossToolsScript="$sourceDir/build/scripts/build_cross_tools"
49960d8d8fcSIngo WeinholdbuildCrossToolsJobs=
500c2b76f7fSJonathan SchleiferuseClang=0
501c0e8cc1aSIngo WeinholduseGccGraphiteDefault=0
502c0e8cc1aSIngo WeinholdunknownArchIndex=1
503483b28e4SIngo WeinholdhaikuTargetArchs=
5047c4641d0SOliver Tappe
5057c4641d0SOliver Tappe# exported (BuildSetup) default parameter values
5067c4641d0SOliver Tappe#
5077c4641d0SOliver TappeHOST_GCC_RAW_VERSION=`gcc -dumpversion`
5087c4641d0SOliver TappeHOST_GCC_MACHINE=`gcc -dumpmachine`
5097c4641d0SOliver TappeHAIKU_INCLUDE_GPL_ADDONS=0
5107c4641d0SOliver TappeHAIKU_INCLUDE_PATENTED_CODE=0
51176fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES=0
5127c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY=0
5137c4641d0SOliver TappeHAIKU_ENABLE_MULTIUSER=0
5147c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY=default
5157c4641d0SOliver TappeTARGET_PLATFORM=haiku
5167c4641d0SOliver TappeHAIKU_USE_GCC_PIPE=0
5177986925fSIngo WeinholdHAIKU_HOST_USE_32BIT=0
5187986925fSIngo WeinholdHAIKU_HOST_USE_XATTR=0
519bc96e8f3SIngo WeinholdHAIKU_HOST_USE_XATTR_REF=0
5202ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY=0
521f04f7042SNiels Sascha ReedijkHOST_EXTENDED_REGEX_SED="sed -r"
5227c4641d0SOliver TappeHOST_GCC_LD=`gcc -print-prog-name=ld`
5237c4641d0SOliver TappeHOST_GCC_OBJCOPY=`gcc -print-prog-name=objcopy`
524c505b276SFrançois RevolSFDISK_BINARY=sfdisk
525c505b276SFrançois RevolHOST_SFDISK=$SFDISK_BINARY
5262a5d0aafSIngo WeinholdHOST_SHA256=
527e173a1ecSIngo WeinholdHOST_HAIKU_PORTER=
528e173a1ecSIngo WeinholdHAIKU_PORTS=
529e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS=
530e70c4c64SPulkoMandyHAIKU_BOOT_BOARD=
5312a5d0aafSIngo Weinhold
532c0e8cc1aSIngo WeinholdHAIKU_PACKAGING_ARCHS=
533c0e8cc1aSIngo Weinhold
534a04a520bSJonathan Schleiferset_default_value HAIKU_NASM		nasm
535c0e8cc1aSIngo Weinhold
5363942ca0dSIngo Weinholdif sha256sum < /dev/null > /dev/null 2>&1; then
5372a5d0aafSIngo Weinhold	HOST_SHA256=sha256sum
5383942ca0dSIngo Weinholdelif sha256 < /dev/null > /dev/null 2>&1; then
5392a5d0aafSIngo Weinhold	HOST_SHA256="sha256 -q"
540b5a871b1SNiels Sascha Reedijkelif shasum < /dev/null > /dev/null 2>&1; then
541b5a871b1SNiels Sascha Reedijk	HOST_SHA256="shasum -a 256"
5422a5d0aafSIngo Weinholdelse
5432a5d0aafSIngo Weinhold	echo "Error: Neither sha256sum nor sha256 seem to be available!" >&2
5442a5d0aafSIngo Weinhold	exit 1
5452a5d0aafSIngo Weinholdfi
546338b8dc3SIngo Weinhold
547cc91b333SIngo WeinholdhaikuRequiredLegacyGCCVersion="2.95.3-haiku-2013_08_15"
548a559f87aSFrançois Revolexport haikuRequiredLegacyGCCVersion
549af4bf973SOliver Tappe	# version of legacy gcc required to build haiku
550483b28e4SIngo WeinholdsupportedTargetArchs="
551483b28e4SIngo Weinhold	arm
552483b28e4SIngo Weinhold	m68k
553483b28e4SIngo Weinhold	ppc
554483b28e4SIngo Weinhold	x86
555483b28e4SIngo Weinhold	x86_64
556483b28e4SIngo Weinhold	x86_gcc2
557483b28e4SIngo Weinhold	"
558e70c4c64SPulkoMandysupportedTargetBoards="
559e70c4c64SPulkoMandy	beagle
560e70c4c64SPulkoMandy	pi
561e70c4c64SPulkoMandy	verdex
562e70c4c64SPulkoMandy	"
563af4bf973SOliver Tappe
5647c4641d0SOliver Tappe# determine output directory
5657c4641d0SOliver Tappeif [ "$currentDir" = "$sourceDir" ]; then
5667c4641d0SOliver Tappe	outputDir=$currentDir/generated
5677c4641d0SOliver Tappeelse
5687c4641d0SOliver Tappe	outputDir=$currentDir
5697c4641d0SOliver Tappefi
5707c4641d0SOliver TappebuildOutputDir="$outputDir/build"
5717c4641d0SOliver TappeHAIKU_BUILD_ATTRIBUTES_DIR="$outputDir/attributes"
5727c4641d0SOliver TappebuildConfigFile="$buildOutputDir/BuildConfig"
5737c4641d0SOliver Tappe
5747c4641d0SOliver Tappe# check for update request
5757c4641d0SOliver Tappeif [ "$1" = "--update" ]; then
5767c4641d0SOliver Tappe	if ! [ -e "$buildConfigFile" ]; then
5777c4641d0SOliver Tappe		echo $0 --update: \'$buildConfigFile\' not found - updating not possible.
5787c4641d0SOliver Tappe		exit 1
5797c4641d0SOliver Tappe	fi
5807c4641d0SOliver Tappe	if ! type perl >/dev/null 2>&1; then
5817c4641d0SOliver Tappe		echo $0 --update: \'perl\' not found - updating not possible.
5827c4641d0SOliver Tappe		exit 1
5837c4641d0SOliver Tappe	fi
5847c4641d0SOliver Tappe	# convert BuildConfig from jam format to shell format and evaluate it
5857c4641d0SOliver Tappe	shellConfigFile="${buildConfigFile}.shell"
5867c4641d0SOliver Tappe	perl "$sourceDir/build/scripts/convert_build_config_to_shell_format.pl" \
5877c4641d0SOliver Tappe		<"$buildConfigFile" >"$shellConfigFile"
5887c4641d0SOliver Tappe	. "$shellConfigFile"
5897c4641d0SOliver Tappe	rm "$shellConfigFile"
5907c4641d0SOliver Tappe	shift
5917c4641d0SOliver Tappefi
5927c4641d0SOliver Tappe
593022fa244SIngo Weinhold# parse parameters
594022fa244SIngo Weinhold#
59520ab75e6SIngo Weinholdwhile [ $# -gt 0 ] ; do
596022fa244SIngo Weinhold	case "$1" in
597e173a1ecSIngo Weinhold		--bootstrap)
598e173a1ecSIngo Weinhold			assertparams "$1" 3 $#
599e173a1ecSIngo Weinhold			HOST_HAIKU_PORTER="`absolute_path $2`"
600e173a1ecSIngo Weinhold			HAIKU_PORTS_CROSS="`absolute_path $3`"
601e173a1ecSIngo Weinhold			HAIKU_PORTS="`absolute_path $4`"
602*502882dbSJessica Hamilton			check_file_exists "$HOST_HAIKU_PORTER" || (
603*502882dbSJessica Hamilton				echo "Invalid path to haikuporter: $HOST_HAIKU_PORTER" >&2
60439d444a3SArvind S Raj				exit 1
60539d444a3SArvind S Raj			)
60639d444a3SArvind S Raj			check_dir_exists "$HAIKU_PORTS" || (
60739d444a3SArvind S Raj				echo "Non-existent directory $HAIKU_PORTS" >&2
60839d444a3SArvind S Raj				exit 1
60939d444a3SArvind S Raj			)
61039d444a3SArvind S Raj			check_dir_exists "$HAIKU_PORTS_CROSS" || (
61139d444a3SArvind S Raj				echo "Non-existent directory $HAIKU_PORTS_CROSS" >&2
61239d444a3SArvind S Raj				exit 1
61339d444a3SArvind S Raj			)
614e173a1ecSIngo Weinhold			shift 4
615e173a1ecSIngo Weinhold			;;
616c0e8cc1aSIngo Weinhold		--build-cross-tools)
617c0e8cc1aSIngo Weinhold			if [ -z "$buildCrossTools" ]; then
6189b0dd528SIngo Weinhold				assertparams "$1" 2 $#
619c0e8cc1aSIngo Weinhold				targetArch=$2
6209b0dd528SIngo Weinhold				buildCrossTools=$3
6219b0dd528SIngo Weinhold				shift 3
622c0e8cc1aSIngo Weinhold			else
623c0e8cc1aSIngo Weinhold				assertparam "$1" $#
624c0e8cc1aSIngo Weinhold				targetArch=$2
625c0e8cc1aSIngo Weinhold				shift 2
626c0e8cc1aSIngo Weinhold			fi
627c0e8cc1aSIngo Weinhold			case "$targetArch" in
628c0e8cc1aSIngo Weinhold				x86_gcc2)	targetMachine=i586-pc-haiku;;
629c0e8cc1aSIngo Weinhold				x86)		targetMachine=i586-pc-haiku;;
630c0e8cc1aSIngo Weinhold				x86_64)		targetMachine=x86_64-unknown-haiku;;
631c0e8cc1aSIngo Weinhold				ppc)		targetMachine=powerpc-apple-haiku;;
632c0e8cc1aSIngo Weinhold				m68k)		targetMachine=m68k-unknown-haiku;;
633c0e8cc1aSIngo Weinhold				arm)		targetMachine=arm-unknown-haiku;;
634c0e8cc1aSIngo Weinhold				*)
635c0e8cc1aSIngo Weinhold					echo "Unsupported target architecture: $2" >&2
636c0e8cc1aSIngo Weinhold					exit 1
637c0e8cc1aSIngo Weinhold					;;
638c0e8cc1aSIngo Weinhold			esac
639c0e8cc1aSIngo Weinhold			set_variable buildCrossToolsMachine_$targetArch $targetMachine
640c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
641c0e8cc1aSIngo Weinhold			HAIKU_PACKAGING_ARCHS=
6429b0dd528SIngo Weinhold			;;
6439b0dd528SIngo Weinhold		--cross-tools-prefix)
6449b0dd528SIngo Weinhold			assertparam "$1" $#
645c0e8cc1aSIngo Weinhold			targetArch=unknown${unknownArchIndex}
646c0e8cc1aSIngo Weinhold			set_variable crossToolsPrefix_$targetArch "$2"
647c0e8cc1aSIngo Weinhold			targetArchs="$targetArchs $targetArch"
648c0e8cc1aSIngo Weinhold			HAIKU_PACKAGING_ARCHS=
649d68208faSMatt Madia			unknownArchIndex=$(($unknownArchIndex + 1))
6509b0dd528SIngo Weinhold			shift 2
6519b0dd528SIngo Weinhold			;;
652a66c32ddSIngo Weinhold		--distro-compatibility)
6539b0dd528SIngo Weinhold			assertparam "$1" $#
6547c4641d0SOliver Tappe			HAIKU_DISTRO_COMPATIBILITY=$2
6557c4641d0SOliver Tappe			case "$HAIKU_DISTRO_COMPATIBILITY" in
656a66c32ddSIngo Weinhold				official)	;;
657a66c32ddSIngo Weinhold				compatible)	;;
658a66c32ddSIngo Weinhold				default)	;;
659a66c32ddSIngo Weinhold				*)			echo "Invalid distro compatibility" \
6607c4641d0SOliver Tappe								"level: $HAIKU_DISTRO_COMPATIBILITY"
661a66c32ddSIngo Weinhold							exit 1;;
662a66c32ddSIngo Weinhold			esac
6639b0dd528SIngo Weinhold			shift 2
6649b0dd528SIngo Weinhold			;;
6657c4641d0SOliver Tappe		--enable-multiuser)	HAIKU_ENABLE_MULTIUSER=1; shift 1;;
66660d8d8fcSIngo Weinhold		--help | -h)	usage; exit 0;;
6672ebcd86dSIngo Weinhold		--host-only)	HAIKU_HOST_BUILD_ONLY=1; shift 1;;
6687c4641d0SOliver Tappe		--include-gpl-addons)	HAIKU_INCLUDE_GPL_ADDONS=1; shift 1;;
6697c4641d0SOliver Tappe		--include-patented-code)	HAIKU_INCLUDE_PATENTED_CODE=1; shift 1;;
67076fa0be3SIngo Weinhold		--include-sources)	HAIKU_INCLUDE_SOURCES=1; shift 1;;
6717c4641d0SOliver Tappe		--include-3rdparty)	HAIKU_INCLUDE_3RDPARTY=1; shift 1;;
67260d8d8fcSIngo Weinhold        -j*)				buildCrossToolsJobs="$1"; shift 1;;
6737c4641d0SOliver Tappe		--target=*)     TARGET_PLATFORM=`echo $1 | cut -d'=' -f2-`; shift 1;;
674483b28e4SIngo Weinhold		--target-arch)
675483b28e4SIngo Weinhold			assertparam "$1" $#
676483b28e4SIngo Weinhold			targetArch=$2
677483b28e4SIngo Weinhold			shift 2
678483b28e4SIngo Weinhold			if [ ! "$platform" = Haiku ]; then
679483b28e4SIngo Weinhold				echo "--target-arch can only be specified on Haiku." >&2
680483b28e4SIngo Weinhold				exit 1
681483b28e4SIngo Weinhold			fi
682483b28e4SIngo Weinhold			is_in_list "$targetArch" "$supportedTargetArchs" || (
683483b28e4SIngo Weinhold				echo "Unsupported target architecture: \"$targetArch\"" >&2
684483b28e4SIngo Weinhold				exit 1
685483b28e4SIngo Weinhold			)
686483b28e4SIngo Weinhold			haikuTargetArchs="$haikuTargetArchs $targetArch"
687483b28e4SIngo Weinhold			;;
688e70c4c64SPulkoMandy		--target-board)
689e70c4c64SPulkoMandy			assertparam "$1" $#
690e70c4c64SPulkoMandy			HAIKU_BOOT_BOARD=$2
691e70c4c64SPulkoMandy			is_in_list "$HAIKU_BOOT_BOARD" "$supportedTargetBoards" || (
692e70c4c64SPulkoMandy				echo "Unsupported target board: \"$HAIKU_BOOT_BOARD\"" >&2
693e70c4c64SPulkoMandy				exit 1
694e70c4c64SPulkoMandy			)
695e70c4c64SPulkoMandy			shift 2
696e70c4c64SPulkoMandy			;;
697c2b76f7fSJonathan Schleifer		--use-clang) useClang=1; shift 1;;
6987c4641d0SOliver Tappe		--use-gcc-pipe)	HAIKU_USE_GCC_PIPE=1; shift 1;;
699c0e8cc1aSIngo Weinhold		--use-gcc-graphite)	useGccGraphiteDefault=1; shift 1;;
7007986925fSIngo Weinhold		--use-32bit)	HAIKU_HOST_USE_32BIT=1; shift 1;;
7017986925fSIngo Weinhold		--use-xattr)	HAIKU_HOST_USE_XATTR=1; shift 1;;
702bc96e8f3SIngo Weinhold		--use-xattr-ref)	HAIKU_HOST_USE_XATTR_REF=1; shift 1;;
703022fa244SIngo Weinhold		*)				echo Invalid argument: \`$1\'; exit 1;;
704022fa244SIngo Weinhold	esac
705022fa244SIngo Weinholddone
706022fa244SIngo Weinhold
7070df3cc9cSIngo Weinhold# detect the build platform
708338b8dc3SIngo Weinholdcase "${platform}" in
7097c4641d0SOliver Tappe	Darwin)	HOST_PLATFORM=darwin ;;
7107c4641d0SOliver Tappe	FreeBSD)	HOST_PLATFORM=freebsd
711c505b276SFrançois Revol				SFDISK_BINARY=sfdisk-linux
7127986925fSIngo Weinhold				if [ "$HAIKU_HOST_USE_32BIT" = 1 ] ; then
7135abd9a46SIngo Weinhold					echo Unsupported platform: FreeBSD ${platformMachine}
714308c212cSIngo Weinhold					exit 1
715308c212cSIngo Weinhold				fi	;;
7167c4641d0SOliver Tappe	Haiku)	HOST_PLATFORM=haiku_host ;;
7177c4641d0SOliver Tappe	Linux)	HOST_PLATFORM=linux ;;
7187c4641d0SOliver Tappe	OpenBSD) HOST_PLATFORM=openbsd ;;
7197c4641d0SOliver Tappe	SunOS)	HOST_PLATFORM=sunos ;;
7207c4641d0SOliver Tappe	CYGWIN_NT-*) HOST_PLATFORM=cygwin ;;
721338b8dc3SIngo Weinhold	*)		echo Unsupported platform: ${platform}
7224cbe4925SAxel Dörfler			exit 1 ;;
7234cbe4925SAxel Dörfleresac
72452a38012Sejakowatz
725c505b276SFrançois Revol# check common locations for sfdisk
726c505b276SFrançois Revolfor sfdiskDir in /sbin /usr/sbin /usr/local/sbin ; do
727c505b276SFrançois Revol	if [ -e ${sfdiskDir}/${SFDISK_BINARY} ]; then
728c505b276SFrançois Revol		HOST_SFDISK=${sfdiskDir}/${SFDISK_BINARY}
729c505b276SFrançois Revol	fi
730c505b276SFrançois Revoldone
731c505b276SFrançois Revol
7320962132cSAlex Smith# check for case-sensitive filesystem
7330962132cSAlex Smithmkdir haikuCaseTest 2>/dev/null
7340962132cSAlex Smithmkdir haikucasetest 2>/dev/null
7350962132cSAlex SmithcaseInsensitive=$?
73697f5a0bdSAlex Smithrmdir haikuCaseTest haikucasetest 2>/dev/null
7370962132cSAlex Smithif [ $caseInsensitive != 0 ]; then
7383ecc5287SMichael Lotz	echo "You need a case-sensitive file-system to build Haiku."
7390962132cSAlex Smith	if [ $HOST_PLATFORM = "darwin" ]; then
7400962132cSAlex Smith		echo "You can create a case-sensitive disk image using Disk Utility and use"
7410962132cSAlex Smith		echo "it to store the Haiku sources on."
7423ecc5287SMichael Lotz	fi
7430962132cSAlex Smith	exit 1
7443ecc5287SMichael Lotzfi
7453ecc5287SMichael Lotz
746f04f7042SNiels Sascha Reedijk# determine how to invoke sed with extended regexp support for non-GNU sed
747f04f7042SNiels Sascha Reedijkif [ $HOST_PLATFORM = "darwin" ]; then
748f04f7042SNiels Sascha Reedijk	HOST_EXTENDED_REGEX_SED="sed -E"
749f04f7042SNiels Sascha Reedijkfi
750f04f7042SNiels Sascha Reedijk
751338b8dc3SIngo Weinhold# create output directory
7526e7c6fe5SIngo Weinholdmkdir -p "$buildOutputDir" || exit 1
753338b8dc3SIngo Weinhold
7542ebcd86dSIngo Weinholdif [ "$HAIKU_HOST_BUILD_ONLY" = 1 ]; then
7552ebcd86dSIngo Weinhold	invalidCommand=$sourceDir/build/scripts/host_build_only
7562ebcd86dSIngo Weinhold	HAIKU_AR=$invalidCommand
7572ebcd86dSIngo Weinhold	HAIKU_CC=$invalidCommand
7582ebcd86dSIngo Weinhold	HAIKU_LD=$invalidCommand
7592ebcd86dSIngo Weinhold	HAIKU_OBJCOPY=$invalidCommand
7602ebcd86dSIngo Weinhold	HAIKU_RANLIB=$invalidCommand
7612ebcd86dSIngo Weinhold	HAIKU_ELFEDIT=$invalidCommand
762d6f80927SJonathan Schleifer	HAIKU_NASM=$invalidCommand
7632ebcd86dSIngo Weinhold	HAIKU_STRIP=$invalidCommand
7642ebcd86dSIngo Weinholdelse
765c0e8cc1aSIngo Weinhold	if [ -n "$HAIKU_PACKAGING_ARCHS" ]; then
766c0e8cc1aSIngo Weinhold		targetArchs="$HAIKU_PACKAGING_ARCHS"
767c0e8cc1aSIngo Weinhold	fi
768c0e8cc1aSIngo Weinhold	HAIKU_PACKAGING_ARCHS=
769c0e8cc1aSIngo Weinhold
770483b28e4SIngo Weinhold	# On Haiku determine target architectures and tools automatically.
771c0e8cc1aSIngo Weinhold	if [ -z "$targetArchs" ]; then
772483b28e4SIngo Weinhold		if [ $HOST_PLATFORM != haiku_host ]; then
773483b28e4SIngo Weinhold			echo "Please specify the build tools to use or build (via" \
774eaef83a9SJeroen Oortwijn				"--cross-tools-prefix or --build-cross-tools) or specify a" \
775483b28e4SIngo Weinhold				"host-only build (--host-only)." >&2
776483b28e4SIngo Weinhold			exit 1
777483b28e4SIngo Weinhold		fi
778483b28e4SIngo Weinhold
779483b28e4SIngo Weinhold		# determine primary architecture
780dda53eaeSIngo Weinhold		targetArch=`package list -i /system/packages/haiku-*.hpkg \
781483b28e4SIngo Weinhold			| sed '/^\s*architecture:/!d; s,^\s*architecture:\s*,,'`
782483b28e4SIngo Weinhold		is_in_list "$targetArch" "$supportedTargetArchs" || (
783483b28e4SIngo Weinhold			echo "Unsupported target architecture: \"$targetArch\"" >&2
784483b28e4SIngo Weinhold			exit 1
785483b28e4SIngo Weinhold		)
786c0e8cc1aSIngo Weinhold		targetArchs=$targetArch
787483b28e4SIngo Weinhold
788c0e8cc1aSIngo Weinhold		set_default_value HAIKU_AR_$targetArch			ar
789c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CC_$targetArch			gcc
790c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LD_$targetArch			ld
791c0e8cc1aSIngo Weinhold		set_default_value HAIKU_OBJCOPY_$targetArch		objcopy
792c0e8cc1aSIngo Weinhold		set_default_value HAIKU_RANLIB_$targetArch		ranlib
793c0e8cc1aSIngo Weinhold		set_default_value HAIKU_ELFEDIT_$targetArch		elfedit
794c0e8cc1aSIngo Weinhold		set_default_value HAIKU_STRIP_$targetArch		strip
795483b28e4SIngo Weinhold
796483b28e4SIngo Weinhold		# determine secondary architectures
797483b28e4SIngo Weinhold		for targetArch in $supportedTargetArchs; do
79880262a91SMatt Madia			if [ -e /system/packages/haiku_$targetArch-*.hpkg ]; then
799483b28e4SIngo Weinhold				targetArchs="$targetArchs $targetArch"
800483b28e4SIngo Weinhold				set_default_value HAIKU_AR_$targetArch		ar-$targetArch
801483b28e4SIngo Weinhold				set_default_value HAIKU_CC_$targetArch		gcc-$targetArch
802483b28e4SIngo Weinhold				set_default_value HAIKU_LD_$targetArch		ld-$targetArch
803483b28e4SIngo Weinhold				set_default_value HAIKU_OBJCOPY_$targetArch	objcopy-$targetArch
804483b28e4SIngo Weinhold				set_default_value HAIKU_RANLIB_$targetArch	ranlib-$targetArch
805483b28e4SIngo Weinhold				set_default_value HAIKU_ELFEDIT_$targetArch	elfedit-$targetArch
806483b28e4SIngo Weinhold				set_default_value HAIKU_STRIP_$targetArch	strip-$targetArch
807483b28e4SIngo Weinhold			fi
808483b28e4SIngo Weinhold		done
809483b28e4SIngo Weinhold
810483b28e4SIngo Weinhold		# The target architectures might have been specified explicitly.
811483b28e4SIngo Weinhold		if [ -n "$haikuTargetArchs" ]; then
812483b28e4SIngo Weinhold			for targetArch in $haikuTargetArchs; do
813483b28e4SIngo Weinhold				is_in_list "$targetArch" "$targetArchs" || (
814483b28e4SIngo Weinhold					echo "Unsupported target architecture: \"$targetArch\"." \
815483b28e4SIngo Weinhold						"Only native architectures of the host platform can" \
816483b28e4SIngo Weinhold						"be specified." >&2
817483b28e4SIngo Weinhold					exit 1
818483b28e4SIngo Weinhold				)
819483b28e4SIngo Weinhold			done
820483b28e4SIngo Weinhold			targetArchs="$haikuTargetArchs"
821483b28e4SIngo Weinhold		fi
822c0e8cc1aSIngo Weinhold	fi
823c0e8cc1aSIngo Weinhold
82468ccc989SIngo Weinhold	isPrimaryArch=1
825c0e8cc1aSIngo Weinhold	for targetArch in $targetArchs; do
826c0e8cc1aSIngo Weinhold		# Note: targetArch is "unknown<n>" at this point, if a cross-tools
827c0e8cc1aSIngo Weinhold		# prefix was specified. The standard_gcc_settings call below will get
828c0e8cc1aSIngo Weinhold		# the actual architecture.
829c0e8cc1aSIngo Weinhold
830c0e8cc1aSIngo Weinhold		crossToolsPrefix=`get_variable crossToolsPrefix_$targetArch`
831c0e8cc1aSIngo Weinhold
832338b8dc3SIngo Weinhold		# build cross tools from sources
833c0e8cc1aSIngo Weinhold		if [ -n "$buildCrossTools" -a -z "$crossToolsPrefix" ]; then
834c0e8cc1aSIngo Weinhold			crossToolsDir="$outputDir/cross-tools-$targetArch"
835c0e8cc1aSIngo Weinhold			targetMachine=`get_variable buildCrossToolsMachine_$targetArch`
836c0e8cc1aSIngo Weinhold			script="$buildCrossToolsScript"
8378304ec7cSIngo Weinhold			scriptArgs=
838c0e8cc1aSIngo Weinhold			if [ $targetArch != x86_gcc2 ]; then
8398304ec7cSIngo Weinhold				script="${script}_gcc4"
8408304ec7cSIngo Weinhold				scriptArgs="$targetMachine"
8411e93288eSJérôme Duval				set_default_value HAIKU_USE_GCC_GRAPHITE_$targetArch	\
8421e93288eSJérôme Duval					$useGccGraphiteDefault
843c0e8cc1aSIngo Weinhold			fi
84468ccc989SIngo Weinhold			secondaryArch=
84568ccc989SIngo Weinhold			if [ -z "$isPrimaryArch" ]; then
84668ccc989SIngo Weinhold				secondaryArch=$targetArch
84768ccc989SIngo Weinhold			fi
84886de8c37SIngo Weinhold
84986de8c37SIngo Weinhold			case $HOST_PLATFORM in
85086de8c37SIngo Weinhold				freebsd|openbsd)	MAKE=gmake;;
85186de8c37SIngo Weinhold				*)					MAKE=make;;
85286de8c37SIngo Weinhold			esac
85386de8c37SIngo Weinhold
85486de8c37SIngo Weinhold			MAKE=$MAKE \
85568ccc989SIngo Weinhold			SECONDARY_ARCH=$secondaryArch \
856c0e8cc1aSIngo Weinhold			HAIKU_USE_GCC_GRAPHITE=`get_variable \
857c0e8cc1aSIngo Weinhold				HAIKU_USE_GCC_GRAPHITE_$targetArch` \
858b3ece905SJérôme Duval			HAIKU_USE_GCC_PIPE=$HAIKU_USE_GCC_PIPE \
8598304ec7cSIngo Weinhold			"$script" $scriptArgs "$sourceDir" "$buildCrossTools" \
8608304ec7cSIngo Weinhold				"$crossToolsDir" $buildCrossToolsJobs || exit 1
861c0e8cc1aSIngo Weinhold			crossToolsPrefix="$crossToolsDir/bin/${targetMachine}-"
862338b8dc3SIngo Weinhold		fi
863338b8dc3SIngo Weinhold
864c0e8cc1aSIngo Weinhold		# prepare gcc settings and get the actual target architecture
865c0e8cc1aSIngo Weinhold		gcc="${crossToolsPrefix}gcc"
866c0e8cc1aSIngo Weinhold		if [ -z "${crossToolsPrefix}" ]; then
867c0e8cc1aSIngo Weinhold			gcc=`get_variable HAIKU_CC_$targetArch`
868338b8dc3SIngo Weinhold		fi
869c0e8cc1aSIngo Weinhold		standard_gcc_settings "$gcc"
870c0e8cc1aSIngo Weinhold		targetArch=$standard_gcc_settings_targetArch
871338b8dc3SIngo Weinhold
872c0e8cc1aSIngo Weinhold		# set default values for flags
873c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CPPFLAGS_$targetArch	""
874c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CCFLAGS_$targetArch		""
875c0e8cc1aSIngo Weinhold		set_default_value HAIKU_CXXFLAGS_$targetArch	""
876c0e8cc1aSIngo Weinhold		set_default_value HAIKU_LDFLAGS_$targetArch		""
877c0e8cc1aSIngo Weinhold		set_default_value HAIKU_ARFLAGS_$targetArch		cru
878c0e8cc1aSIngo Weinhold		set_default_value HAIKU_UNARFLAGS_$targetArch	x
879338b8dc3SIngo Weinhold
880c0e8cc1aSIngo Weinhold		# Override the cross tools variables, if the tools were built or a
881c0e8cc1aSIngo Weinhold		# prefix was specified.
882b7777272SAlex Smith		if [ -n "$crossToolsPrefix" ]; then
883c0e8cc1aSIngo Weinhold			get_build_tool_path AR_$targetArch ${crossToolsPrefix}ar
884c0e8cc1aSIngo Weinhold			get_build_tool_path LD_$targetArch ${crossToolsPrefix}ld
885c0e8cc1aSIngo Weinhold			get_build_tool_path OBJCOPY_$targetArch ${crossToolsPrefix}objcopy
886c0e8cc1aSIngo Weinhold			get_build_tool_path RANLIB_$targetArch ${crossToolsPrefix}ranlib
887c0e8cc1aSIngo Weinhold			get_build_tool_path STRIP_$targetArch ${crossToolsPrefix}strip
888c0e8cc1aSIngo Weinhold
889c0e8cc1aSIngo Weinhold			case `get_variable HAIKU_GCC_RAW_VERSION_$targetArch` in
890bd16f0ddSAlex Smith				4.*)
891c0e8cc1aSIngo Weinhold					get_build_tool_path ELFEDIT_$targetArch \
892c0e8cc1aSIngo Weinhold						${crossToolsPrefix}elfedit
893bd16f0ddSAlex Smith				;;
894bd16f0ddSAlex Smith			esac
89552a38012Sejakowatz		fi
89652a38012Sejakowatz
897c0e8cc1aSIngo Weinhold		# Get the libgcc objects. We couldn't do that in standard_gcc_settings,
898c0e8cc1aSIngo Weinhold		# since we need "ar", which may be set later.
899c0e8cc1aSIngo Weinhold		ar=`get_variable HAIKU_AR_$targetArch`
900c0e8cc1aSIngo Weinhold		libgcc=`get_variable HAIKU_GCC_LIBGCC_$targetArch`
901c0e8cc1aSIngo Weinhold		set_variable HAIKU_GCC_LIBGCC_OBJECTS_$targetArch \
902c0e8cc1aSIngo Weinhold			"`$ar t $libgcc | grep -v eabi.o`"
903c0e8cc1aSIngo Weinhold			# Note: We filter out eabi.o. It's present in gcc's libgcc for PPC
904c0e8cc1aSIngo Weinhold			# and neither needed nor wanted.
905c0e8cc1aSIngo Weinhold
906ef57df3dSIngo Weinhold		# check whether the Haiku compiler really targets Haiku
907c0e8cc1aSIngo Weinhold		targetMachine=`get_variable HAIKU_GCC_MACHINE_$targetArch`
908c0e8cc1aSIngo Weinhold		case "$targetMachine" in
909eedc3d0bSIngo Weinhold			*-*-haiku)	;;
910c0e8cc1aSIngo Weinhold			*)
911c0e8cc1aSIngo Weinhold				echo The compiler specified as Haiku target compiler is not a \
912c0e8cc1aSIngo Weinhold				valid Haiku cross-compiler. Please see ReadMe.cross-compile. >&2
913eedc3d0bSIngo Weinhold				echo compiler: $HAIKU_CC
914c0e8cc1aSIngo Weinhold				echo compiler is configured for target: $targetMachine
915eedc3d0bSIngo Weinhold				exit 1 ;;
916eedc3d0bSIngo Weinhold		esac
917c0e8cc1aSIngo Weinhold
918c0e8cc1aSIngo Weinhold		HAIKU_PACKAGING_ARCHS="$HAIKU_PACKAGING_ARCHS $targetArch"
91968ccc989SIngo Weinhold		isPrimaryArch=
920c0e8cc1aSIngo Weinhold	done
9212ebcd86dSIngo Weinholdfi
922eedc3d0bSIngo Weinhold
92352a38012Sejakowatz# Generate BuildConfig
9247c4641d0SOliver Tappecat << EOF > "$buildConfigFile"
92552a38012Sejakowatz# BuildConfig
926ab2540c4SIngo Weinhold# Note: This file has been automatically generated by configure with the
927ab2540c4SIngo Weinhold# following arguments:
92855d267a4SFrançois Revol# ${configureArgs}
92952a38012Sejakowatz
9307c4641d0SOliver TappeTARGET_PLATFORM 			?= "${TARGET_PLATFORM}" ;
9317c4641d0SOliver TappeHOST_PLATFORM				?= "${HOST_PLATFORM}" ;
932338b8dc3SIngo Weinhold
9337c4641d0SOliver TappeHAIKU_INCLUDE_GPL_ADDONS			?= "${HAIKU_INCLUDE_GPL_ADDONS}" ;
9347c4641d0SOliver TappeHAIKU_INCLUDE_PATENTED_CODE			?= "${HAIKU_INCLUDE_PATENTED_CODE}" ;
93576fa0be3SIngo WeinholdHAIKU_INCLUDE_SOURCES				?= "${HAIKU_INCLUDE_SOURCES}" ;
9367c4641d0SOliver TappeHAIKU_INCLUDE_3RDPARTY				?= "${HAIKU_INCLUDE_3RDPARTY}" ;
9377c4641d0SOliver TappeHAIKU_ENABLE_MULTIUSER				?= "${HAIKU_ENABLE_MULTIUSER}" ;
9387c4641d0SOliver TappeHAIKU_DISTRO_COMPATIBILITY			?= "${HAIKU_DISTRO_COMPATIBILITY}" ;
9397c4641d0SOliver TappeHAIKU_USE_GCC_PIPE					?= "${HAIKU_USE_GCC_PIPE}" ;
9407986925fSIngo WeinholdHAIKU_HOST_USE_32BIT				?= "${HAIKU_HOST_USE_32BIT}" ;
9417986925fSIngo WeinholdHAIKU_HOST_USE_XATTR				?= "${HAIKU_HOST_USE_XATTR}" ;
942bc96e8f3SIngo WeinholdHAIKU_HOST_USE_XATTR_REF			?= "${HAIKU_HOST_USE_XATTR_REF}" ;
9432ebcd86dSIngo WeinholdHAIKU_HOST_BUILD_ONLY				?= "${HAIKU_HOST_BUILD_ONLY}" ;
944eccc7665SIngo Weinhold
945c0e8cc1aSIngo WeinholdHAIKU_PACKAGING_ARCHS		?= ${HAIKU_PACKAGING_ARCHS} ;
94665ad1ba3SAlex Smith
9477c4641d0SOliver TappeHAIKU_BUILD_ATTRIBUTES_DIR	?= ${HAIKU_BUILD_ATTRIBUTES_DIR} ;
948338b8dc3SIngo Weinhold
949d6f80927SJonathan SchleiferHAIKU_NASM					?= ${HAIKU_NASM} ;
950e70c4c64SPulkoMandyHAIKU_BOOT_BOARD			?= ${HAIKU_BOOT_BOARD} ;
951338b8dc3SIngo Weinhold
952f04f7042SNiels Sascha ReedijkHOST_EXTENDED_REGEX_SED		?= ${HOST_EXTENDED_REGEX_SED} ;
9537c4641d0SOliver TappeHOST_GCC_RAW_VERSION		?= ${HOST_GCC_RAW_VERSION} ;
9547c4641d0SOliver TappeHOST_GCC_MACHINE			?= ${HOST_GCC_MACHINE} ;
9557c4641d0SOliver TappeHOST_LD						?= ${HOST_GCC_LD} ;
9567c4641d0SOliver TappeHOST_OBJCOPY				?= ${HOST_GCC_OBJCOPY} ;
957c505b276SFrançois RevolHOST_SFDISK					?= ${HOST_SFDISK} ;
9582a5d0aafSIngo WeinholdHOST_SHA256					?= ${HOST_SHA256} ;
9598b5934c9SIngo Weinhold
960e173a1ecSIngo WeinholdHOST_HAIKU_PORTER			?= ${HOST_HAIKU_PORTER} ;
961e173a1ecSIngo WeinholdHAIKU_PORTS					?= ${HAIKU_PORTS} ;
962e173a1ecSIngo WeinholdHAIKU_PORTS_CROSS			?= ${HAIKU_PORTS_CROSS} ;
963e173a1ecSIngo Weinhold
964c4786ea6SlilloEOF
965c4786ea6Slillo
966c0e8cc1aSIngo Weinholdfor targetArch in $HAIKU_PACKAGING_ARCHS; do
967c0e8cc1aSIngo Weinhold	variables="
968c0e8cc1aSIngo Weinhold		HAIKU_GCC_RAW_VERSION		HAIKU_GCC_RAW_VERSION
969c0e8cc1aSIngo Weinhold		HAIKU_GCC_MACHINE			HAIKU_GCC_MACHINE
970c0e8cc1aSIngo Weinhold		HAIKU_GCC_LIB_DIR			HAIKU_GCC_LIB_DIR
971c0e8cc1aSIngo Weinhold		HAIKU_GCC_LIBGCC			HAIKU_GCC_LIBGCC
972c0e8cc1aSIngo Weinhold		HAIKU_CPU					HAIKU_CPU
973c0e8cc1aSIngo Weinhold		HAIKU_STATIC_LIBSTDC++		HAIKU_STATIC_LIBSTDCXX
974c0e8cc1aSIngo Weinhold		HAIKU_SHARED_LIBSTDC++		HAIKU_SHARED_LIBSTDCXX
975c0e8cc1aSIngo Weinhold		HAIKU_STATIC_LIBSUPC++		HAIKU_STATIC_LIBSUPCXX
976c0e8cc1aSIngo Weinhold		HAIKU_SHARED_LIBSUPC++		HAIKU_SHARED_LIBSUPCXX
977c0e8cc1aSIngo Weinhold		HAIKU_KERNEL_LIBGCC			HAIKU_KERNEL_LIBGCC
978c0e8cc1aSIngo Weinhold		HAIKU_KERNEL_LIBSUPC++		HAIKU_KERNEL_LIBSUPCXX
979c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBGCC			HAIKU_BOOT_LIBGCC
980c0e8cc1aSIngo Weinhold		HAIKU_BOOT_LIBSUPC++		HAIKU_BOOT_LIBSUPCXX
981c0e8cc1aSIngo Weinhold		HAIKU_AR					HAIKU_AR
982c0e8cc1aSIngo Weinhold		HAIKU_CC					HAIKU_CC
983c2b76f7fSJonathan Schleifer		HAIKU_CC_IS_CLANG			HAIKU_CC_IS_CLANG
984c0e8cc1aSIngo Weinhold		HAIKU_LD					HAIKU_LD
985c0e8cc1aSIngo Weinhold		HAIKU_OBJCOPY				HAIKU_OBJCOPY
986c0e8cc1aSIngo Weinhold		HAIKU_RANLIB				HAIKU_RANLIB
987c0e8cc1aSIngo Weinhold		HAIKU_ELFEDIT				HAIKU_ELFEDIT
988c0e8cc1aSIngo Weinhold		HAIKU_STRIP					HAIKU_STRIP
989c0e8cc1aSIngo Weinhold		HAIKU_CPPFLAGS				HAIKU_CPPFLAGS
990c0e8cc1aSIngo Weinhold		HAIKU_CCFLAGS				HAIKU_CCFLAGS
991c0e8cc1aSIngo Weinhold		HAIKU_C++FLAGS				HAIKU_CXXFLAGS
992c0e8cc1aSIngo Weinhold		HAIKU_LDFLAGS				HAIKU_LDFLAGS
993c0e8cc1aSIngo Weinhold		HAIKU_ARFLAGS				HAIKU_ARFLAGS
994c0e8cc1aSIngo Weinhold		HAIKU_UNARFLAGS				HAIKU_UNARFLAGS
995c0e8cc1aSIngo Weinhold		HAIKU_USE_GCC_GRAPHITE		HAIKU_USE_GCC_GRAPHITE
996c0e8cc1aSIngo Weinhold		"
997c0e8cc1aSIngo Weinhold	set -- $variables
998c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
999c0e8cc1aSIngo Weinhold		value=`get_variable ${2}_$targetArch`
1000c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= $value ;" >> "$buildConfigFile"
1001c0e8cc1aSIngo Weinhold		shift 2
1002c0e8cc1aSIngo Weinhold	done
1003b1e5b60cSAxel Dörfler
1004c0e8cc1aSIngo Weinhold	# For variables that may have long values, distribute them over multiple
1005c0e8cc1aSIngo Weinhold	# lines so that jam doesn't hit the maximum line length.
1006c0e8cc1aSIngo Weinhold	variables="
1007c0e8cc1aSIngo Weinhold		HAIKU_GCC_HEADERS_DIR		HAIKU_GCC_HEADERS_DIR
1008c0e8cc1aSIngo Weinhold		HAIKU_C++_HEADERS_DIR		HAIKU_CXX_HEADERS_DIR
100966a7f29fSJérôme Duval		HAIKU_BOOT_C++_HEADERS_DIR	HAIKU_BOOT_CXX_HEADERS_DIR
1010c0e8cc1aSIngo Weinhold		HAIKU_GCC_LIBGCC_OBJECTS	HAIKU_GCC_LIBGCC_OBJECTS
1011c0e8cc1aSIngo Weinhold		"
1012c0e8cc1aSIngo Weinhold	set -- $variables
1013c0e8cc1aSIngo Weinhold	while [ $# -ge 2 ]; do
1014c0e8cc1aSIngo Weinhold		echo "${1}_${targetArch} ?= " >> "$buildConfigFile"
1015c0e8cc1aSIngo Weinhold		get_variable ${2}_$targetArch | xargs -n 1 echo "   " \
1016c0e8cc1aSIngo Weinhold			>> "$buildConfigFile"
1017c0e8cc1aSIngo Weinhold		echo "    ;" >> "$buildConfigFile"
1018c0e8cc1aSIngo Weinhold		shift 2
1019c0e8cc1aSIngo Weinhold	done
1020c0e8cc1aSIngo Weinholddone
1021b1e5b60cSAxel Dörfler
1022b1e5b60cSAxel Dörfler
10239b0dd528SIngo Weinhold# Generate a boot strap Jamfile in the output directory.
1024338b8dc3SIngo Weinhold
1025338b8dc3SIngo Weinholdcat << EOF > $outputDir/Jamfile
1026338b8dc3SIngo Weinhold# automatically generated Jamfile
1027338b8dc3SIngo Weinhold
1028338b8dc3SIngo WeinholdHAIKU_TOP			= ${sourceDir} ;
1029338b8dc3SIngo WeinholdHAIKU_OUTPUT_DIR	= ${outputDir} ;
1030338b8dc3SIngo Weinhold
1031338b8dc3SIngo Weinholdinclude [ FDirName \$(HAIKU_TOP) Jamfile ] ;
1032338b8dc3SIngo Weinhold
1033338b8dc3SIngo WeinholdEOF
1034